package bbdd;


import beans.DatosProgramaLavado;
import beans.Usuario;

import com.mysql.jdbc.jdbc2.optional.MysqlDataSource;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

public class BaseDeDatos {
	
	private String user;
    private String passwd;
    private String database;
    private Connection conexion;

    public String getUser() {
        return this.user;
    }

    public void setUser(String user) {
        this.user = user;
    }
    
    public String getPasswd() {
        return this.passwd;
    }
    
    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }
    
    public String getDatabase() {
        return this.database;
    }

    public void setDatabase(String database) {
        this.database = database;
    }

    public Connection getConexion(){
        return conexion;
    }
    public void setConexion(Connection conexion){
        this.conexion = conexion;
    }

    public BaseDeDatos() {
    }

    public BaseDeDatos(String user, String passwd, String database) {
        this.user = user;
        this.passwd = passwd;
        this.database = database;
    }

    public void conectar(){
        
        MysqlDataSource dataSource = new MysqlDataSource();
        dataSource.setUser(this.user);
        dataSource.setPassword(this.passwd);
        dataSource.setDatabaseName(this.database);
        dataSource.setServerName("localhost");
        
        try{
            this.conexion = dataSource.getConnection();
        }catch(SQLException e){
            e.printStackTrace();
        }
    }
    
    public void desconectar(){
        
        try{
            this.conexion.close();
        }catch(SQLException e){
            e.printStackTrace();
        }   
    }
    
    
    public int nuevoUsuario(Usuario user){
    	
    	int iduser = 0;
    	try{
    		PreparedStatement psExecute;
            String sql = "INSERT INTO user (age,city,country,job,opinion,people,sex,status,typedishwasher,useweek,time) " +
            		"VALUES ("+user.getAge()+",\""+user.getCity()+"\",\""+user.getCountry()+"\",\""+user.getJob()+"\",\""+user.getOpinion()+"\","+user.getPeople()+",\""+user.getSex()+"\",\""+user.getStatus()+"\",\""+user.getTypedishwasher()+"\","+user.getUseweek()+",CURDATE());";
            psExecute = conexion.prepareStatement(sql);
            psExecute.executeUpdate();
            psExecute.close();
    		
            ResultSet rs2;
            PreparedStatement psExecute2;
            String sql2 = "SELECT MAX(id) FROM user;";
            psExecute2 = conexion.prepareStatement(sql2);
            rs2 = psExecute2.executeQuery();
            while(rs2.next()){
            	iduser = rs2.getInt("MAX(id)");
            }
    	}catch(SQLException e){
    		e.printStackTrace();
    	}
    	
    	return iduser;
    	
    }
    
public void nuevoDatosPrograma(ArrayList<DatosProgramaLavado> datos,int user){
    	
    	
    	try{
    		
    		for(DatosProgramaLavado aux:datos){
    			
    			if(aux.getUse()!=0){
    	
	    		PreparedStatement psExecute;
	            String sql = "INSERT INTO programdata (id_user,f_load,program,soil,type,f_use) " +
	            		"VALUES ("+user+",\""+aux.getLoad()+"\",\""+aux.getProgram()+"\",\""+aux.getSoil()+"\",\""+aux.getType()+"\","+aux.getUse()+");";
	            psExecute = conexion.prepareStatement(sql);
	            psExecute.executeUpdate();
	            psExecute.close();
    			}
    		}
    		
           
    	}catch(SQLException e){
    		e.printStackTrace();
    	}
    
	
}


}
